<template>
  <div
    v-if="(isAuctionEnded && isCurrentStateNoBids) || isAuction || (isFirstApprove && isSpotListActual)"
    :class="['spot-indicators', isDownGrade ? '--downgrade' : '--blind' ]"
  >
    <i v-if="isDownGrade" class="icon profile-eye" />
    <span v-if="isDownGrade">{{ spotViewsCount }}</span>
    <i v-if="isDownGrade" class="icon auction" />
    <span v-if="isDownGrade">{{ spotBidsCount }}</span>
    <i
      v-if="isDownGrade || (isBlind && !auctionCurrentPrice) || (isFirstApprove && isSpotListActual)"
      class="icon clock"
    />
    <ObCountdown
      v-if="isDownGrade || (isBlind && !auctionCurrentPrice) || (isFirstApprove && isSpotListActual)"
      :class="{
        '-light-raspberry-red': suitPeriodOfTime
      }"
      :duration="lifeTime"
    />
  </div>
</template>

<script>
import { mapGetters } from 'vuex'
import ObCountdown from 'common-components/src/obComponents/obCountdown/index'

export default {
  name: 'indicators',
  components: { ObCountdown },
  props: {
    spotViewsCount: {
      type: Number,
      default: null,
    },
    spotBidsCount: {
      type: Number,
      default: null,
    },
    spotEndTime: {
      type: String,
      default: '',
    },
    spotOrderStatus: {
      type: String,
      default: '',
    },
    spotAuctionInfoCurrentState: {
      type: String,
      default: '',
    },
    spotType: {
      type: String,
      default: '',
    },
  },
  computed: {
    ...mapGetters({
      spotAuctionByCarrier: 'spot/spotAuctionByCarrier',
    }),
    isAuction() {
      return this.spotOrderStatus === 'AUCTION'
    },
    isAuctionEnded() {
      return this.spotOrderStatus === 'AUCTION_ENDED'
    },
    isCurrentStateNoBids() {
      return this.spotAuctionInfoCurrentState === 'NO_BIDS'
    },
    lifeTime() {
      return Math.round((Date.parse(this.spotEndTime) - Date.now()) / 1000)
    },
    isDownGrade() {
      return this.spotType === 'DOWNGRADE'
    },
    isBlind() {
      return this.spotType === 'BLIND'
    },
    isFirstApprove() {
      return this.spotType === 'FIRST_APPROVE'
    },
    auctionCurrentPrice() {
      return this.spotAuctionByCarrier.auctionInfo.currentPrice;
    },
    isSpotListActual() {
      return this.$route.path === '/spot-list'
    },
    suitPeriodOfTime () {
      return this.lifeTime >= 0 && this.lifeTime <= 3600
    }
  },
}
</script>

<style scoped lang="scss">
.spot-indicators {
  display: flex;
  justify-content: center;
  padding-top: 18px;
  align-items: center;
  font-size: 14px;
  letter-spacing: 0.4px;
  color: $color-text-base;
  &.--downgrade {
    margin-left: -5px;
  }
  .icon {
    margin: 0 6px 0 10px;
    font-size: 18px;
    color: $color-blue-navy-blue;
  }
}
</style>
